<div class="container-fluid">
<%= _.template($('#input_constructor').html())({
	id: "abreqjqs",
	description:tr("Text for slicing"),
	default_selector: "string",
	disable_int: true,
	value_string: "",
	help:
	{
		description:tr("It is necessary to specify the text to be cut")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "fivpdijl",
	description:tr("Character limit"),
	default_selector: "int",
	disable_string: true,
	value_number: 860,
	min_number: 1,
	max_number: 999999,
	help:
	{
		description:tr("Maximum size (number of characters) of a text sentence")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "hyxoasaj",
	description: "unicode_flag",
	default_selector: "expression",
	disable_int: true,
	disable_string: true,
	value_string: "false",
	variants:["false","true"],
	help:
	{
		description:tr("Character analysis by unicode table")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "ycdfxign",
	description: "concat_flag",
	default_selector: "expression",
	disable_int: true,
	disable_string: true,
	value_string: "false",
	variants:["false","true"],
	help:
	{
		description:tr("Reduce all nested arrays to one")
	}
}) %>
<%= _.template($('#variable_constructor').html())({
	id: "Save",
	description: "Нарезанный текст (массив)",
	default_variable: "TEXT_SLICED",
	help:
	{
		description:tr("An array comes to the output. If the limit on the size of the offer is exceeded, a nested split array will be sent in response.")
	}
}) %>
</div>
<div class="tooltipinternal">
<div class="tr tooltip-paragraph-first-fold">Function for cutting text to a fixed size, taking into account punctuation marks.</div>
</div>
<%= _.template($('#back').html())({action:"executeandadd", visible:true}) %>
<%= "<s" + "cript>" %>
		$(document).ready(function(){
			let ksOkButton = document.getElementById('ok')
			ksOkButton.style.backgroundColor = '#2197f3'
			ksOkButton.style.borderColor = '#4a8af4'
			let ksVariables = document.querySelectorAll(".variable-input");
			for (let i = 0; i < ksVariables.length; i++) {
				ksVariables[i].style.color = "#2197f3";
			}
			});
<%= "</" + "script>" %>