<div class="container-fluid">
<%= _.template($('#input_constructor').html())({
	id: "vwdjqnkn",
	description:tr("Translate from"),
	default_selector: "string",
	disable_int: true,
	value_string: "Автоопределение",
	variants: [
		"Автоопределение",
		"Английский",
		"Болгарский",
		"Венгерский",
		"Греческий",
		"Датский",
		"Индонезийский",
		"Испанский",
		"Итальянский",
		"Китайский (упрощенный)",
		"Латышский",
		"Литовский",
		"Немецкий",
		"Нидерландский",
		"Польский",
		"Португальский",
		"Румынский",
		"Русский",
		"Словацкий",
		"Словенский",
		"Турецкий",
		"Украинский",
		"Финский",
		"Французский",
		"Чешский",
		"Шведский",
		"Эстонский",
		"Японский"
	],
	help:
	{
		description:tr("It is necessary to select the language from which you want to translate")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "yqgorley",
	description:tr("Translate to"),
	default_selector: "string",
	disable_int: true,
	value_string: "Английский",
	variants: [
		"Английский",
		"Болгарский",
		"Венгерский",
		"Греческий",
		"Датский",
		"Индонезийский",
		"Испанский",
		"Итальянский",
		"Китайский (упрощенный)",
		"Латышский",
		"Литовский",
		"Немецкий",
		"Нидерландский",
		"Польский",
		"Португальский",
		"Румынский",
		"Русский",
		"Словацкий",
		"Словенский",
		"Турецкий",
		"Украинский",
		"Финский",
		"Французский",
		"Чешский",
		"Шведский",
		"Эстонский",
		"Японский"
	],
	help:
	{
		description:tr("It is necessary to select the language to be translated into")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "vourqobr",
	description:tr("Text to translate"),
	default_selector: "string",
	disable_int: true,
	value_string: "",
	help:
	{
		description:tr("It is necessary to specify the text to be translated")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "vvwvseui",
	description:tr("Proxy"),
	default_selector: "string",
	disable_int: true,
	value_string: "",
	help:
	{
		description:tr("A line with information about the IP address")
	}
}) %>
<%= _.template($('#input_constructor').html())({
	id: "sottioqj",
	description:tr("UserAgent"),
	default_selector: "string",
	disable_int: true,
	value_string: "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/107.0.0.0 Safari/537.36",
	help:
	{
		description:tr("The User-Agent header with information about the browser version")
	}
}) %>
<%= _.template($('#variable_constructor').html())({
	id: "Save",
	description:tr("Translation result"),
	default_variable: "TRANSLATE",
	help:
	{
		description:tr("The variable in which to save the translation result by the service")+" "+"Deepl"
	}
}) %>
</div>
<div class="tooltipinternal">
<div class="tooltip-paragraph-first"><span class="tr">Link to online translator</span> Deepl <a href="#" onclick="BrowserAutomationStudio_OpenUrl('https://www.deepl.com/en/translator); return false;">https://www.deepl.com/en/translator</a></div>
<div class="tooltip-paragraph-first-fold"><span class="tr">Link to the browser extension</span> Deepl <a href="#" onclick="BrowserAutomationStudio_OpenUrl('https://chrome.google.com/webstore/detail/cofdbpoegempjloogbagkncekinflcnj'); return false;">https://chrome.google.com/webstore/detail/cofdbpoegempjloogbagkncekinflcnj</a></div>
</div>
<%= _.template($('#back').html())({action:"executeandadd", visible:true}) %>
<%= "<s" + "cript>" %>
		$(document).ready(function(){
			let ksOkButton = document.getElementById('ok')
			ksOkButton.style.backgroundColor = '#2197f3'
			ksOkButton.style.borderColor = '#4a8af4'
			let ksVariables = document.querySelectorAll(".variable-input");
			for (let i = 0; i < ksVariables.length; i++) {
				ksVariables[i].style.color = "#2197f3";
			}
			});
<%= "</" + "script>" %>