// Html декодирование
var unescapeHTML = function(a) {
	return a.replace(/&([^;]+);/g, function(b, c) {
		switch (c) {
			case "amp":
			return "&";
			case "lt":
			return "<";
			case "gt":
			return ">";
			case "quot":
			return '"';
			default:
			return "#" != c.charAt(0) || (c = Number("0" + c.slice(1)),
				isNaN(c)) ? b : String.fromCharCode(c)
		}
	})
}

// Проверка на энкод, выполнение декод
var get_unescapeHTML = function(a) {
	return -1 != a.indexOf("&") ? unescapeHTML(a) : a
}

// Html кодирование
var escapeHTML = function(a) {
	var pattern = /[\x00&<>"']/;
	if (!pattern.test(a))
		return a; -
	1 != a.indexOf("&") && (a = a.replace(/&/g, "&amp;")); -
	1 != a.indexOf("<") && (a = a.replace(/</g, "&lt;")); -
	1 != a.indexOf(">") && (a = a.replace(/>/g, "&gt;")); -
	1 != a.indexOf('"') && (a = a.replace(/"/g, "&quot;")); -
	1 != a.indexOf("'") && (a = a.replace(/'/g, "&#39;")); -
	1 != a.indexOf("\x00") && (a = a.replace(/\x00/g, "&#0;"));
	return a
}

function Translator_unescape_HTML() {
	var text = _function_argument("text")
	var resultat = get_unescapeHTML(text)
	_function_return(resultat)
}


function Translator_escape_HTML() {
	var text = _function_argument("text")
	var resultat = escapeHTML(text)
	_function_return(resultat)
}

function Translator_translate_bing_rest_sid() {
	// Парсим входные данные
	var proxy = _function_argument("proxy")
	var ua = _function_argument("ua")

	// Валидация прокси
	var hash = proxy_parse(proxy)
	if ("auto" != "auto") {
		hash["IsHttp"] = "auto" == "http"
	}
	var login = ""
	var password = ""
	if (login.length > 0 && password.length > 0) {
		hash["name"] = login
		hash["password"] = password
	}

    //Переключить HTTP-клиент во внутренний режим
    _switch_http_client_internal()
    http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
    http_client_set_header("User-Agent", ua)
    http_client_get2("https://www.bing.com/translator", {
    	method: ("GET"),
    	headers: ("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9")
    })!
    var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()

    // IG
    var regexp_resultat = native("regexp", "first", JSON.stringify({
    	text: response,
    	regexp: "\u0022ig\u0022:\u0022([A-Z0-9]+)\u0022"
    }))
    if (regexp_resultat.length == 0)
    	regexp_resultat = []
    else
    	regexp_resultat = JSON.parse(regexp_resultat)
    var all_match = regexp_resultat.pop()
    if (typeof(all_match) == 'undefined' || !all_match)
    	all_match = ""
    var IG = regexp_resultat[0]
    if (typeof(IG) == 'undefined' || !IG)
    	IG = ""
    if (regexp_resultat.length == 0) {
    	IG = all_match
    }

    // TRANSLATE_PARAMS
    var regexp_resultat = native("regexp", "first", JSON.stringify({
    	text: response,
    	regexp: "var params_RichTranslateHelper = (.*?);"
    }))
    if (regexp_resultat.length == 0)
    	regexp_resultat = []
    else
    	regexp_resultat = JSON.parse(regexp_resultat)
    var all_match = regexp_resultat.pop()
    if (typeof(all_match) == 'undefined' || !all_match)
    	all_match = ""
    var TRANSLATE_PARAMS  = regexp_resultat[0]
    if (typeof(TRANSLATE_PARAMS) == 'undefined' || !TRANSLATE_PARAMS)
    	TRANSLATE_PARAMS = ""
    if (regexp_resultat.length == 0) {
    	TRANSLATE_PARAMS = all_match
    }

    // KEY, TOKEN
    var param = JSON.parse(TRANSLATE_PARAMS)
    KEY = param[0]
    TOKEN = param[1]
    _function_return(IG + "|" + TOKEN + "|" + KEY)
 }

function Translator_translate_bing_rest() {
 	var country1 = _function_argument("country1")
 	var country2 = _function_argument("country2")
 	var text = _function_argument("text")
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var sid = _function_argument("sid")
 	var countrys = {
 		"Автоопределение": "auto-detect",
 		"Английский": "en",
 		"Chinese (Literary)": "lzh",
 		"Inuinnaqtun": "ikt",
 		"Inuktitut (Latin)": "iu-Latn",
 		"Mongolian (Cyrillic)": "mn-Cyrl",
 		"Mongolian (Traditional)": "mn-Mong",
 		"Азербайджанский": "az",
 		"Албанский": "sq",
 		"Амхарский": "am",
 		"Арабский": "ar",
 		"Армянский": "hy",
 		"Ассамский": "as",
 		"Африкаанс": "af",
 		"Баскский": "eu",
 		"Башкирский": "ba",
 		"Бенгальский": "bn",
 		"Бирманский": "my",
 		"Болгарский": "bg",
 		"Боснийский": "bs",
 		"Валлийский": "cy",
 		"Венгерский": "hu",
 		"Верхнелужицкий": "hsb",
 		"Вьетнамский": "vi",
 		"Гаитянский": "ht",
 		"Галисийский": "gl",
 		"Греческий": "el",
 		"Грузинский": "ka",
 		"Гуджарати": "gu",
 		"Дари": "prs",
 		"Датский": "da",
 		"Зулу": "zu",
 		"Иврит": "he",
 		"Индонезийский": "id",
 		"Инуктитут": "iu",
 		"Ирландский": "ga",
 		"Исландский": "is",
 		"Испанский": "es",
 		"Итальянский": "it",
 		"Казахский": "kk",
 		"Каннада": "kn",
 		"Кантонский (Традиционная Китайская)": "yue",
 		"Каталанский": "ca",
 		"Киргизский": "ky",
 		"Китайский (Традиционная Китайская)": "zh-Hant",
 		"Китайский (Упрощенная Китайская)": "zh-Hans",
 		"Клингонский (Латиница)": "tlh-Latn",
 		"Корейский": "ko",
 		"Курдский (Северная)": "kmr",
 		"Курдский (Центральная)": "ku",
 		"Кхмерский": "km",
 		"Лаосский": "lo",
 		"Латышский": "lv",
 		"Литовский": "lt",
 		"Македонский": "mk",
 		"Малагасийский": "mg",
 		"Малайский": "ms",
 		"Малаялам": "ml",
 		"Мальдивский": "dv",
 		"Мальтийский": "mt",
 		"Маори": "mi",
 		"Маратхи": "mr",
 		"Немецкий": "de",
 		"Непальский": "ne",
 		"Нидерландский": "nl",
 		"Норвежский Букмол": "nb",
 		"Ория": "or",
 		"Отоми (Керетаро)": "otq",
 		"Панджаби": "pa",
 		"Персидский": "fa",
 		"Польский": "pl",
 		"Португальский (Бразилия)": "pt",
 		"Португальский (Португалия)": "pt-PT",
 		"Пушту": "ps",
 		"Румынский": "ro",
 		"Русский": "ru",
 		"Самоанский": "sm",
 		"Сербский (Кириллица)": "sr-Cyrl",
 		"Сербский (Латиница)": "sr-Latn",
 		"Словацкий": "sk",
 		"Словенский": "sl",
 		"Сомали": "so",
 		"Суахили": "sw",
 		"Таитянский": "ty",
 		"Тайский": "th",
 		"Тамильский": "ta",
 		"Татарский": "tt",
 		"Телугу": "te",
 		"Тибетский": "bo",
 		"Тигринья": "ti",
 		"Тонганский": "to",
 		"Турецкий": "tr",
 		"Туркменский": "tk",
 		"Узбекский": "uz",
 		"Уйгурский": "ug",
 		"Украинский": "uk",
 		"Урду": "ur",
 		"Фарерский": "fo",
 		"Фиджи": "fj",
 		"Филиппинский": "fil",
 		"Финский": "fi",
 		"Французский": "fr",
 		"Французский (Канада)": "fr-CA",
 		"Хинди": "hi",
 		"Хмонг": "mww",
 		"Хорватский": "hr",
 		"Чешский": "cs",
 		"Шведский": "sv",
 		"Эстонский": "et",
 		"Юкатекский Майя": "yua",
 		"Японский": "ja"
 	}
 	var lang_code1 = countrys[country1]
 	if (!lang_code1) {
 		fail_user("Error in determining the language \"From\"!", false)
 	}
 	var lang_code2 = countrys[country2]
 	if (!lang_code2) {
 		fail_user("Error in determining the language \"To\"!", false)
 	}
 	var service = 'bing'
 	var text_data = text_preparation(text, service);
 	text_query = text_data.query
 	text_full = text_data.full
 	text_arr = text_data.arr
 	text_type = text_data.type
 	var zero = text_data.zero
 	if(zero) {
 		_function_return(text)
 	}

 	var sid_arr = sid.split('|')
 	if(sid_arr.length != 3){
 		fail_user("Error getting the parameter sid!", false)
 	}
 	var IG = sid_arr[0];
 	var TOKEN = sid_arr[1];
 	var KEY = sid_arr[2];
 	if (!(IG.length) || !(TOKEN.length) || !(KEY.length)) {
 		fail_user("Error getting the parameter sid!", false)
 	}
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
    //Переключить HTTP-клиент во внутренний режим
    _switch_http_client_internal()
    http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
    http_client_set_header("User-Agent", ua)
    http_client_post("https://www.bing.com/ttranslatev3?isVertical=1\u0026\u0026IG=" + IG + "\u0026IID=translator.5024.1", 
    	["data", "\u0026fromLang=" + lang_code1 + "\u0026to=" + lang_code2 + "\u0026" + text_query + "\u0026token=" + TOKEN + "\u0026key=" + KEY], 
    	{
    		"content-type": "custom/" + ("application/x-www-form-urlencoded"),
    		"encoding": ("UTF-8"),
    		"method": ("POST"),
    		headers: ("")
    	})!
    var response = http_client_encoded_content("auto")
 	//Переключить HTTP-клиент в основной режим
 	_switch_http_client_main()
    // Подготовка тела запроса
    var fotmattedResponse = function(resp, text_full, text_arr, text_type) {
    	try {
    		resp = JSON.parse(resp)[0];
    	} catch (err) {
    		fail_user("Translate response error \(failed parsed response\)\!", false);
    	}
    	if (resp.translations < 1) {
    		fail_user("Translate response error \(failed response code\)\!", false);
    	}
    	var text = (resp.translations[0].text).split(/\r\n|\r|\n/g);
    	var resultat;
    	for (var i = 0; i < text.length; i++) {
    		var el1, el2, item;
    		el1 = text_arr[i];
    		el2 = text[i];
    		resultat = text_full.replace(el1, get_unescapeHTML(el2));
    	}
    	if(text_type){
    		resultat = resultat.split(/\r\n|\r|\n/g);
    	}
    	return resultat;
    }
    var resultat = fotmattedResponse(response, text_full, text_arr, text_type)
    _function_return(resultat)
 }

function Translator_translate_deepl_rest() {
 	var country1 = _function_argument("country1")
 	var country2 = _function_argument("country2")
 	var text = _function_argument("text")
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var countrys = {
 		"Автоопределение": "auto",
 		"Английский": "EN",
 		"Болгарский": "BG",
 		"Венгерский": "HU",
 		"Греческий": "EL",
 		"Датский": "DA",
 		"Индонезийский": "ID",
 		"Испанский": "ES",
 		"Итальянский": "IT",
 		"Китайский (упрощенный)": "ZH",
 		"Латышский": "LV",
 		"Литовский": "LT",
 		"Немецкий": "DE",
 		"Нидерландский": "NL",
 		"Польский": "PL",
 		"Португальский": "PT",
 		"Румынский": "RO",
 		"Русский": "RU",
 		"Словацкий": "SK",
 		"Словенский": "SL",
 		"Турецкий": "TR",
 		"Украинский": "UK",
 		"Финский": "FI",
 		"Французский": "FR",
 		"Чешский": "CS",
 		"Шведский": "SV",
 		"Эстонский": "ET",
 		"Японский": "JA"
 	}
 	var lang_code1 = countrys[country1]
 	if (!lang_code1) {
 		fail_user("Error in determining the language \"From\"!", false)
 	}
 	var lang_code2 = countrys[country2]
 	if (!lang_code2) {
 		fail_user("Error in determining the language \"To\"!", false)
 	}
 	var service = 'deepl'
 	var text_data = text_preparation(text, service);
 	text_query = JSON.stringify((text_data.arr).join('\r\n'))
 	text_full = text_data.full
 	text_arr = text_data.arr
 	text_type = text_data.type
 	var zero = text_data.zero
 	if(zero) {
 		_function_return(text)
 	}
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
 	//Переключить HTTP-клиент во внутренний режим
 	_switch_http_client_internal()
 	http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
 	http_client_set_header("User-Agent", ua)
 	var timestamp = Date.now()
 	var sid = rand(1,9)+""+Array(9).join().split(',').map(function() {
 		return ("0123456789").charAt(Math.floor(Math.random() * "0123456789".length));
 	}).join('')

 	http_client_post("https://www2.deepl.com/jsonrpc?client=chrome-extension,1.4.0", 
 		["data", "\u007b\u0022jsonrpc\u0022:\u00222.0\u0022,\u0022method\u0022: \u0022LMT_handle_texts\u0022,\u0022params\u0022:\u007b\u0022texts\u0022:[\u007b\u0022text\u0022:" + text_query + "\u007d],\u0022splitting\u0022:\u0022paragraphs\u0022,\u0022lang\u0022:\u007b\u0022target_lang\u0022:\u0022" + lang_code2 + "\u0022,\u0022source_lang_user_selected\u0022:\u0022" + lang_code1 + "\u0022,\u0022preference\u0022:\u007b\u0022weight\u0022:\u007b\u007d\u007d\u007d,\u0022timestamp\u0022:" + timestamp + "\u007d,\u0022id\u0022:" + sid + "\u007d"], 
 		{
 			"content-type": "custom/" + ("application/json"),
 			"encoding": ("UTF-8"),
 			"method": ("POST"),
 			headers: ("Authorization: None\r\nReferer: https://www.deepl.com/")
 		})!
 	var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()
    // Подготовка тела запроса
    var fotmattedResponse = function(resp, text_full, text_arr, text_type) {
    	try {
    		resp = JSON.parse(resp);
    	} catch (err) {
    		fail_user("Translate response error \(failed parsed response\)\!", false);
    	}
    	if (String(resp.id).length != 10) {
    		fail_user("Translate response error \(failed response code\)\!", false);
    	}
    	var text = (resp.result.texts[0].text).split(/\r\n|\r|\n/g);
    	var resultat;
    	for (var i = 0; i < text.length; i++) {
    		var el1, el2, item;
    		el1 = text_arr[i];
    		el2 = text[i];
    		resultat = text_full.replace(el1, get_unescapeHTML(el2));
    	}
    	if(text_type){
    		resultat = resultat.split(/\r\n|\r|\n/g);
    	}
    	return resultat;
    }
    var resultat = fotmattedResponse(response, text_full, text_arr, text_type)
    _function_return(resultat)
 }

function Translator_translate_baidu_api() {
 	var country1 = _function_argument("country1")
 	var country2 = _function_argument("country2")
 	var text = _function_argument("text")
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var appid = _function_argument("appid")
 	var apikey = _function_argument("apikey")
 	var countrys = {
 		'Автоопределение': 'auto',
 		'Английский': 'en',
 		'Арабский': 'ara',
 		'Болгарский': 'bul',
 		'Венгерский': 'hu',
 		'Вьетнамский': 'vie',
 		'Голландский': 'nl',
 		'Греческий': 'el',
 		'Датский': 'dan',
 		'Испанский': 'spa',
 		'Итальянский': 'it',
 		'Кантонский': 'yue',
 		'Китайский (классический)': 'wyw',
 		'Китайский (традиционный)': 'cht',
 		'Китайский': 'zh',
 		'Корейский': 'kor',
 		'Немецкий': 'de',
 		'Польский': 'pl',
 		'Португальский': 'pt',
 		'Румынский': 'rom',
 		'Русский': 'ru',
 		'Словенский': 'slo',
 		'Тайский': 'th',
 		'Финский': 'fin',
 		'Французский': 'fra',
 		'Чешский': 'cs',
 		'Шведский': 'swe',
 		'Эстонский': 'est',
 		'Японский': 'jp'
 	}
	
	// Список языков из rest апи, который хз зачем тут, но пусть будет.
	var countrys_official = {
	    "auto": "Автоопределение",
	    'zh': '中文',
	    'jp': '日语',
	    'jpka': '日语假名',
	    'th': '泰语',
	    'fra': '法语',
	    'en': '英语',
	    'spa': '西班牙语',
	    'kor': '韩语',
	    'tr': '土耳其语',
	    'vie': '越南语',
	    'ms': '马来语',
	    'de': '德语',
	    'ru': '俄语',
	    'ir': '伊朗语',
	    'ara': '阿拉伯语',
	    'est': '爱沙尼亚语',
	    'be': '白俄罗斯语',
	    'bul': '保加利亚语',
	    'hi': '印地语',
	    'is': '冰岛语',
	    'pl': '波兰语',
	    'fa': '波斯语',
	    'dan': '丹麦语',
	    'tl': '菲律宾语',
	    'fin': '芬兰语',
	    'nl': '荷兰语',
	    'ca': '加泰罗尼亚语',
	    'cs': '捷克语',
	    'hr': '克罗地亚语',
	    'lv': '拉脱维亚语',
	    'lt': '立陶宛语',
	    'rom': '罗马尼亚语',
	    'af': '南非语',
	    'no': '挪威语',
	    'pt_BR': '巴西语',
	    'pt': '葡萄牙语',
	    'swe': '瑞典语',
	    'sr': '塞尔维亚语',
	    'eo': '世界语',
	    'sk': '斯洛伐克语',
	    'slo': '斯洛文尼亚语',
	    'sw': '斯瓦希里语',
	    'uk': '乌克兰语',
	    'iw': '希伯来语',
	    'el': '希腊语',
	    'hu': '匈牙利语',
	    'hy': '亚美尼亚语',
	    'it': '意大利语',
	    'id': '印尼语',
	    'sq': '阿尔巴尼亚语',
	    'am': '阿姆哈拉语',
	    'as': '阿萨姆语',
	    'az': '阿塞拜疆语',
	    'eu': '巴斯克语',
	    'bn': '孟加拉语',
	    'bs': '波斯尼亚语',
	    'gl': '加利西亚语',
	    'ka': '格鲁吉亚语',
	    'gu': '古吉拉特语',
	    'ha': '豪萨语',
	    'ig': '伊博语',
	    'iu': '因纽特语',
	    'ga': '爱尔兰语',
	    'zu': '祖鲁语',
	    'kn': '卡纳达语',
	    'kk': '哈萨克语',
	    'ky': '吉尔吉斯语',
	    'lb': '卢森堡语',
	    'mk': '马其顿语',
	    'mt': '马耳他语',
	    'mi': '毛利语',
	    'mr': '马拉提语',
	    'ne': '尼泊尔语',
	    'or': '奥利亚语',
	    'pa': '旁遮普语',
	    'qu': '凯楚亚语',
	    'tn': '塞茨瓦纳语',
	    'si': '僧加罗语',
	    'ta': '泰米尔语',
	    'tt': '塔塔尔语',
	    'te': '泰卢固语',
	    'ur': '乌尔都语',
	    'uz': '乌兹别克语',
	    'cy': '威尔士语',
	    'yo': '约鲁巴语',
	    'yue': '粤语',
	    'wyw': '文言文',
	    'cht': '中文繁体'
	}
 	var lang_code1 = countrys[country1]
 	if (!lang_code1) {
 		fail_user("Error in determining the language \"From\"!", false)
 	}
 	var lang_code2 = countrys[country2]
 	if (!lang_code2) {
 		fail_user("Error in determining the language \"To\"!", false)
 	}
 	var service = 'baidu'
 	var text_data = text_preparation(text, service);
 	text_query = text_data.query
 	text_full = text_data.full
 	text_arr = text_data.arr
 	text_type = text_data.type
 	var zero = text_data.zero
 	if(zero) {
 		_function_return(text)
 	}
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
 	//Переключить HTTP-клиент во внутренний режим
 	_switch_http_client_internal()
 	http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
 	http_client_set_header("User-Agent", ua)
 	var salt = (new Date).getTime()
 	var sign = md5(appid + text_arr.join('\r\n') + salt + apikey)
 	_switch_http_client_main()
 	http_client_get2('http://api.fanyi.baidu.com/api/trans/vip/translate?from=' + lang_code1 + '&to=' + lang_code2 + '&sign=' + sign + '&appid=' + appid + '&salt=' + salt + '&' + text_query, {
 		method: ("GET"),
 		headers: ("")
 	})!
 	var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()
    // Подготовка тела запроса
    var fotmattedResponse = function(resp, text_full, text_arr, text_type) {
    	try {
    		resp = JSON.parse(resp);
    	} catch (err) {
    		fail_user("Translate response error \(failed parsed response\)\!", false);
    	}
    	if (resp.logid > 0) {
    		fail_user("Translate response error \(failed response code\)\!", false);
    	}
    	var text = resp.trans_resultat;
    	var resultat;
    	for (var i = 0; i < text.length; i++) {
    		var el1, el2, item;
    		el1 = text_arr[i];
    		el2 = text[i].dst;
    		resultat = text_full.replace(el1, get_unescapeHTML(el2));
    	}
    	if(text_type){
    		resultat = resultat.split(/\r\n|\r|\n/g);
    	}
    	return resultat;
    }
    var resultat = fotmattedResponse(response, text_full, text_arr, text_type)
    _function_return(resultat)
 }

function Translator_translate_yandex_api() {
 	var country1 = _function_argument("country1")
 	var country2 = _function_argument("country2")
 	var text = _function_argument("text")
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var key = _function_argument("key")
 	var countrys = {
 		"Автоопределение": "auto",
 		"Азербайджанский": "az",
 		"Албанский": "sq",
 		"Амхарский": "am",
 		"Английский": "en",
 		"Арабский": "ar",
 		"Армянский": "hy",
 		"Африкаанс": "af",
 		"Баскский": "eu",
 		"Башкирский": "ba",
 		"Белорусский": "be",
 		"Бенгальский": "bn",
 		"Бирманский": "my",
 		"Болгарский": "bg",
 		"Боснийский": "bs",
 		"Валлийский": "cy",
 		"Венгерский": "hu",
 		"Вьетнамский": "vi",
 		"Гаитянский": "ht",
 		"Галисийский": "gl",
 		"Горномарийский": "mrj",
 		"Греческий": "el",
 		"Грузинский": "ka",
 		"Гуджарати": "gu",
 		"Датский": "da",
 		"Зулу": "zu",
 		"Иврит": "he",
 		"Идиш": "yi",
 		"Индонезийский": "id",
 		"Ирландский": "ga",
 		"Исландский": "is",
 		"Испанский": "es",
 		"Итальянский": "it",
 		"Казахский (латиница)": "kazlat",
 		"Казахский": "kk",
 		"Каннада": "kn",
 		"Каталанский": "ca",
 		"Киргизский": "ky",
 		"Китайский": "zh",
 		"Корейский": "ko",
 		"Коса": "xh",
 		"Кхмерский": "km",
 		"Лаосский": "lo",
 		"Латынь": "la",
 		"Латышский": "lv",
 		"Литовский": "lt",
 		"Люксембургский": "lb",
 		"Македонский": "mk",
 		"Малагасийский": "mg",
 		"Малайский": "ms",
 		"Малаялам": "ml",
 		"Мальтийский": "mt",
 		"Маори": "mi",
 		"Маратхи": "mr",
 		"Марийский": "mhr",
 		"Монгольский": "mn",
 		"Немецкий": "de",
 		"Непальский": "ne",
 		"Нидерландский": "nl",
 		"Норвежский": "no",
 		"Панджаби": "pa",
 		"Папьяменто": "pap",
 		"Персидский": "fa",
 		"Польский": "pl",
 		"Португальский": "pt",
 		"Румынский": "ro",
 		"Русский": "ru",
 		"Себуанский": "ceb",
 		"Сербский": "sr",
 		"Сингальский": "si",
 		"Словацкий": "sk",
 		"Словенский": "sl",
 		"Суахили": "sw",
 		"Сунданский": "su",
 		"Тагальский": "tl",
 		"Таджикский": "tg",
 		"Тайский": "th",
 		"Тамильский": "ta",
 		"Татарский": "tt",
 		"Телугу": "te",
 		"Турецкий": "tr",
 		"Удмуртский": "udm",
 		"Узбекский (кириллица)": "uzbcyr",
 		"Узбекский": "uz",
 		"Украинский": "uk",
 		"Урду": "ur",
 		"Финский": "fi",
 		"Французский": "fr",
 		"Хинди": "hi",
 		"Хорватский": "hr",
 		"Чешский": "cs",
 		"Чувашский": "cv",
 		"Шведский": "sv",
 		"Шотландский (гэльский)": "gd",
 		"Эсперанто": "eo",
 		"Эстонский": "et",
 		"Яванский": "jv",
 		"Якутский": "sah",
 		"Японский": "ja",
 	}
 	lang_code1 = countrys[country1]
 	if (!lang_code1) {
 		fail_user("Error in determining the language \"From\"!", false)
 	}
 	var lang_code2 = countrys[country2]
 	if (!lang_code2) {
 		fail_user("Error in determining the language \"To\"!", false)
 	}
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
 	//Переключить HTTP-клиент во внутренний режим
 	_switch_http_client_internal()
 	http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
 	http_client_set_header("User-Agent", ua)
 	_if(lang_code1 == 'auto',function(){
 		http_client_get2('https://translate.yandex.net/api/v1.5/tr.json/detect?key=' + key + '&text=' + encodeURIComponent(text) + '&options=1', {
 			method: ("GET"),
 			headers: ("")
 		})!
 		var response = http_client_encoded_content("auto")
 		var response_data = JSON.parse(response)
 		if(response_data.code != 200) {
 			fail_user("Error getting the parameter \"Detect language\"!", false)
 		}
 		lang_code1 = response_data.lang
 	})!
 	var service = 'yandex'
 	var text_data = text_preparation(text, service);
 	text_query = text_data.query
 	text_full = text_data.full
 	text_arr = text_data.arr
 	text_type = text_data.type
 	var zero = text_data.zero
 	if(zero) {
 		_function_return(text)
 	}
 	http_client_post("https://translate.yandex.net/api/v1.5/tr.json/translate?key=" + key + "\u0026source_lang=" + lang_code1 + "\u0026target_lang=" + lang_code2, 
 		["data", text_query + "\u0026options=0"], 
 		{
 			"content-type": "custom/" + ("application/x-www-form-urlencoded"),
 			"encoding": ("UTF-8"),
 			"method": ("POST"),
 			headers: ("")
 		})!
 	var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()
    // Подготовка тела запроса
    var fotmattedResponse = function(resp, text_full, text_arr, text_type) {
    	try {
    		resp = JSON.parse(resp);
    	} catch (err) {
    		fail_user("Translate response error \(failed parsed response\)\!", false);
    	}
    	if (resp.code != 200) {
    		fail_user("Translate response error \(failed response code\)\!", false);
    	}
    	var text = resp.text;
    	var resultat;
    	for (var i = 0; i < text_arr.length; i++) {
    		var el1, el2, item;
    		item = text[i];
    		el1 = text_arr[i];
    		if (Array.isArray(item)) {
    			el2 = item[0];
    		} else {
    			el2 = item;
    		}
    		resultat = text_full.replace(el1, get_unescapeHTML(el2));
    	}
    	if(text_type){
    		resultat = resultat.split(/\r\n|\r|\n/g);
    	}
    	return resultat;
    }
    var resultat = fotmattedResponse(response, text_full, text_arr, text_type)
    _function_return(resultat)
 }

function Translator_translate_yandex_rest_sid() {
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
 	//Переключить HTTP-клиент во внутренний режим
 	_switch_http_client_internal()
 	http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
 	http_client_set_header("User-Agent", ua)
 	http_client_get2("https://translate.yandex.com/", {
 		method: ("GET"),
 		headers: ("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\r\nAccept-Encoding: gzip, deflate, br")
 	})!
 	var status = http_client_status()
 	if(status == 302) {
 		fail_user("Translate response error \(captcha appeared\)\!", false)
 	}
 	var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()
    var regexp_resultat = native("regexp", "first", JSON.stringify({
    	text: response,
    	regexp: "Ya.reqid = \u0027(.*?)\u0027;"
    }))
    if (regexp_resultat.length == 0)
    	regexp_resultat = []
    else
    	regexp_resultat = JSON.parse(regexp_resultat)
    var all_match = regexp_resultat.pop()
    if (typeof(all_match) == 'undefined' || !all_match)
    	all_match = ""
    var sid = regexp_resultat[0]
    if (typeof(sid) == 'undefined' || !sid)
    	sid = ""
    if (regexp_resultat.length == 0) {
    	sid = all_match
    }
    _function_return(sid)
 }

function Translator_translate_yandex_rest() {
 	var country1 = _function_argument("country1")
 	var country2 = _function_argument("country2")
 	var text = _function_argument("text")
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var sid = _function_argument("sid")
 	
 	var countrys = {
 		"Автоопределение": "auto",
 		"Азербайджанский": "az",
 		"Албанский": "sq",
 		"Амхарский": "am",
 		"Английский": "en",
 		"Арабский": "ar",
 		"Армянский": "hy",
 		"Африкаанс": "af",
 		"Баскский": "eu",
 		"Башкирский": "ba",
 		"Белорусский": "be",
 		"Бенгальский": "bn",
 		"Бирманский": "my",
 		"Болгарский": "bg",
 		"Боснийский": "bs",
 		"Валлийский": "cy",
 		"Венгерский": "hu",
 		"Вьетнамский": "vi",
 		"Гаитянский": "ht",
 		"Галисийский": "gl",
 		"Горномарийский": "mrj",
 		"Греческий": "el",
 		"Грузинский": "ka",
 		"Гуджарати": "gu",
 		"Датский": "da",
 		"Зулу": "zu",
 		"Иврит": "he",
 		"Идиш": "yi",
 		"Индонезийский": "id",
 		"Ирландский": "ga",
 		"Исландский": "is",
 		"Испанский": "es",
 		"Итальянский": "it",
 		"Казахский (латиница)": "kazlat",
 		"Казахский": "kk",
 		"Каннада": "kn",
 		"Каталанский": "ca",
 		"Киргизский": "ky",
 		"Китайский": "zh",
 		"Корейский": "ko",
 		"Коса": "xh",
 		"Кхмерский": "km",
 		"Лаосский": "lo",
 		"Латынь": "la",
 		"Латышский": "lv",
 		"Литовский": "lt",
 		"Люксембургский": "lb",
 		"Македонский": "mk",
 		"Малагасийский": "mg",
 		"Малайский": "ms",
 		"Малаялам": "ml",
 		"Мальтийский": "mt",
 		"Маори": "mi",
 		"Маратхи": "mr",
 		"Марийский": "mhr",
 		"Монгольский": "mn",
 		"Немецкий": "de",
 		"Непальский": "ne",
 		"Нидерландский": "nl",
 		"Норвежский": "no",
 		"Панджаби": "pa",
 		"Папьяменто": "pap",
 		"Персидский": "fa",
 		"Польский": "pl",
 		"Португальский": "pt",
 		"Румынский": "ro",
 		"Русский": "ru",
 		"Себуанский": "ceb",
 		"Сербский": "sr",
 		"Сингальский": "si",
 		"Словацкий": "sk",
 		"Словенский": "sl",
 		"Суахили": "sw",
 		"Сунданский": "su",
 		"Тагальский": "tl",
 		"Таджикский": "tg",
 		"Тайский": "th",
 		"Тамильский": "ta",
 		"Татарский": "tt",
 		"Телугу": "te",
 		"Турецкий": "tr",
 		"Удмуртский": "udm",
 		"Узбекский (кириллица)": "uzbcyr",
 		"Узбекский": "uz",
 		"Украинский": "uk",
 		"Урду": "ur",
 		"Финский": "fi",
 		"Французский": "fr",
 		"Хинди": "hi",
 		"Хорватский": "hr",
 		"Чешский": "cs",
 		"Чувашский": "cv",
 		"Шведский": "sv",
 		"Шотландский (гэльский)": "gd",
 		"Эсперанто": "eo",
 		"Эстонский": "et",
 		"Яванский": "jv",
 		"Якутский": "sah",
 		"Японский": "ja",
 	}
 	lang_code1 = countrys[country1]
 	if (!lang_code1) {
 		fail_user("Error in determining the language \"From\"!", false)
 	}
 	var lang_code2 = countrys[country2]
 	if (!lang_code2) {
 		fail_user("Error in determining the language \"To\"!", false)
 	}
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
 	//Переключить HTTP-клиент во внутренний режим
 	_switch_http_client_internal()
 	http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
 	http_client_set_header("User-Agent", ua)
 	_if(lang_code1 == 'auto',function(){
 		http_client_get2('http://translate.yandex.net/api/v1/tr.json/detect?sid=' + sid + '&srv=tr-text&text=' + encodeURIComponent(text) + '&options=1', {
 			method: ("GET"),
 			headers: ("")
 		})!
 		var response = http_client_encoded_content("auto")
 		var response_data = JSON.parse(response)
 		if(response_data.code != 200) {
 			fail_user("Error getting the parameter \"Detect language\"!", false)
 		}
 		lang_code1 = response_data.lang
 	})!
 	var service = 'yandex'
 	var text_data = text_preparation(text, service);
 	text_query = text_data.query
 	text_full = text_data.full
 	text_arr = text_data.arr
 	text_type = text_data.type
 	var zero = text_data.zero
 	if(zero) {
 		_function_return(text)
 	}
 	http_client_post("http://translate.yandex.net/api/v1/tr.json/translate?id=" + sid + "-0-0\u0026srv=tr-text\u0026source_lang=" + lang_code1 + "\u0026target_lang=" + lang_code2, 
 		["data", text_query + "\u0026options=0"], 
 		{
 			"content-type": "custom/" + ("application/x-www-form-urlencoded"),
 			"encoding": ("UTF-8"),
 			"method": ("POST"),
 			headers: ("Accept: */*\r\nAccept-Encoding: gzip, deflate, br\r\nOrigin: https://translate.yandex.com\r\nReferer: https://translate.yandex.com/\r\nX-Retpath-Y: https://translate.yandex.com")
 		})!
 	var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()
    // Подготовка тела запроса
    var fotmattedResponse = function(resp, text_full, text_arr, text_type) {
    	try {
    		resp = JSON.parse(resp);
    	} catch (err) {
    		fail_user("Translate response error \(failed parsed response\)\!", false);
    	}
    	if (resp.code != 200) {
    		fail_user("Translate response error \(failed response code\)\!", false);
    	}
    	var text = resp.text;
    	var resultat;
    	for (var i = 0; i < text_arr.length; i++) {
    		var el1, el2, item;
    		item = text[i];
    		el1 = text_arr[i];
    		if (Array.isArray(item)) {
    			el2 = item[0];
    		} else {
    			el2 = item;
    		}
    		resultat = text_full.replace(el1, get_unescapeHTML(el2));
    	}
    	if(text_type){
    		resultat = resultat.split(/\r\n|\r|\n/g);
    	}
    	return resultat;
    }
    var resultat = fotmattedResponse(response, text_full, text_arr, text_type)
    _function_return(resultat)
 }

function Translator_translate_google_rest() {
 	var country1 = _function_argument("country1")
 	var country2 = _function_argument("country2")
 	var text = _function_argument("text")
 	var proxy = _function_argument("proxy")
 	var ua = _function_argument("ua")
 	var countrys = {
 		"Автоопределение": "auto",
 		"Азербайджанский": "az",
 		"Аймара": "ay",
 		"Албанский": "sq",
 		"Амхарский": "am",
 		"Английский": "en",
 		"Арабский": "ar",
 		"Армянский": "hy",
 		"Ассамский": "as",
 		"Африкаанс": "af",
 		"Бамбара": "bm",
 		"Баскский": "eu",
 		"Белорусский": "be",
 		"Бенгальский": "bn",
 		"Бирманский": "my",
 		"Болгарский": "bg",
 		"Боснийский": "bs",
 		"Бходжпури": "bho",
 		"Валлийский": "cy",
 		"Венгерский": "hu",
 		"Вьетнамский": "vi",
 		"Гавайский": "haw",
 		"Галисийский": "gl",
 		"Греческий": "el",
 		"Грузинский": "ka",
 		"Гуарани": "gn",
 		"Гуджарати": "gu",
 		"Датский": "da",
 		"Догри": "doi",
 		"Зулу": "zu",
 		"Иврит": "iw",
 		"Игбо": "ig",
 		"Идиш": "yi",
 		"Илоканский": "ilo",
 		"Индонезийский": "id",
 		"Ирландский": "ga",
 		"Исландский": "is",
 		"Испанский": "es",
 		"Итальянский": "it",
 		"Йоруба": "yo",
 		"Казахский": "kk",
 		"Каннада": "kn",
 		"Каталанский": "ca",
 		"Кечуа": "qu",
 		"Киргизский": "ky",
 		"Китайский (традиционный)": "zh-TW",
 		"Китайский (упрощенный)": "zh-CN",
 		"Конкани": "gom",
 		"Корейский": "ko",
 		"Корсиканский": "co",
 		"Коса": "xh",
 		"Креольский (гаити)": "ht",
 		"Крио": "kri",
 		"Курдский (курманджи)": "ku",
 		"Курдский (сорани)": "ckb",
 		"Кхмерский": "km",
 		"Лаосский": "lo",
 		"Латинский": "la",
 		"Латышский": "lv",
 		"Лингала": "ln",
 		"Литовский": "lt",
 		"Луганда": "lg",
 		"Люксембургский": "lb",
 		"Майтхили": "mai",
 		"Македонский": "mk",
 		"Малагасийский": "mg",
 		"Малайский": "ms",
 		"Малаялам": "ml",
 		"Мальдивский": "dv",
 		"Мальтийский": "mt",
 		"Маори": "mi",
 		"Маратхи": "mr",
 		"Мейтейлон (манипури)": "mni-Mtei",
 		"Мизо": "lus",
 		"Монгольский": "mn",
 		"Немецкий": "de",
 		"Непальский": "ne",
 		"Нидерландский": "nl",
 		"Норвежский": "no",
 		"Ория": "or",
 		"Оромо": "om",
 		"Панджаби": "pa",
 		"Персидский": "fa",
 		"Польский": "pl",
 		"Португальский": "pt",
 		"Пушту": "ps",
 		"Руанда": "rw",
 		"Румынский": "ro",
 		"Русский": "ru",
 		"Самоанский": "sm",
 		"Санскрит": "sa",
 		"Себуанский": "ceb",
 		"Сепеди": "nso",
 		"Сербский": "sr",
 		"Сесото": "st",
 		"Сингальский": "si",
 		"Синдхи": "sd",
 		"Словацкий": "sk",
 		"Словенский": "sl",
 		"Сомалийский": "so",
 		"Суахили": "sw",
 		"Сунданский": "su",
 		"Таджикский": "tg",
 		"Тайский": "th",
 		"Тамильский": "ta",
 		"Татарский": "tt",
 		"Телугу": "te",
 		"Тигринья": "ti",
 		"Тсонга": "ts",
 		"Турецкий": "tr",
 		"Туркменский": "tk",
 		"Узбекский": "uz",
 		"Уйгурский": "ug",
 		"Украинский": "uk",
 		"Урду": "ur",
 		"Филиппинский": "tl",
 		"Финский": "fi",
 		"Французский": "fr",
 		"Фризский": "fy",
 		"Хауса": "ha",
 		"Хинди": "hi",
 		"Хмонг": "hmn",
 		"Хорватский": "hr",
 		"Чви": "ak",
 		"Чева": "ny",
 		"Чешский": "cs",
 		"Шведский": "sv",
 		"Шона": "sn",
 		"Шотландский (гэльский)": "gd",
 		"Эве": "ee",
 		"Эсперанто": "eo",
 		"Эстонский": "et",
 		"Яванский": "jw",
 		"Японский": "ja"
 	}
 	var lang_code1 = countrys[country1]
 	if (!lang_code1) {
 		fail_user("Error in determining the language \"From\"!", false)
 	}
 	var lang_code2 = countrys[country2]
 	if (!lang_code2) {
 		fail_user("Error in determining the language \"To\"!", false)
 	}
 	var service = 'google'
 	var text_data = text_preparation(text, service);
 	text_query = text_data.query
 	text_full = text_data.full
 	text_arr = text_data.arr
 	text_type = text_data.type
 	var zero = text_data.zero
 	var tk = text_data.tk
 	if(zero) {
 		_function_return(text)
 	}
 	var hash = proxy_parse(proxy)
 	if ("auto" != "auto") {
 		hash["IsHttp"] = "auto" == "http"
 	}
 	var login = ""
 	var password = ""
 	if (login.length > 0 && password.length > 0) {
 		hash["name"] = login
 		hash["password"] = password
 	}
   //Переключить HTTP-клиент во внутренний режим
   _switch_http_client_internal()
   http_client_set_proxy(hash["server"], hash["Port"], hash["IsHttp"], hash["name"], hash["password"])
   http_client_set_header("User-Agent", ua)
   http_client_post("https://translate.googleapis.com/translate_a/t?anno=3\u0026client=ft_lib\u0026format=html\u0026v=1.0\u0026key\u0026sl=" + lang_code1 + "\u0026tl=" + lang_code2 + "\u0026tc=2\u0026tk=" + tk + "\u0026mode=1", 
   	["data", text_query], 
   	{
   		"content-type": "custom/" + ("application/x-www-form-urlencoded"),
   		"encoding": ("UTF-8"),
   		"method": ("POST"),
   		headers: ("accept-encoding: gzip, deflate\r\naccept-language: ru-RU,ru;q=0.9,en-US;q=0.8,en;q=0.7,zh-TW;q=0.6,zh;q=0.5\r\norigin: https://translate.googleusercontent.com\r\nreferer: https://translate.googleusercontent.com/")
   	})!
   var response = http_client_encoded_content("auto")
    //Переключить HTTP-клиент в основной режим
    _switch_http_client_main()
    // Подготовка тела запроса
    var fotmattedResponse = function(text, text_full, text_arr, text_type) {
    	try {
    		text = JSON.parse(text);
    	} catch (err) {
    		fail_user("Translate response error \(failed parsed response\)\!", false);
    	}
    	var resultat;
    	for (var i = 0; i < text_arr.length; i++) {
    		var el1, el2, item;
    		item = text[i];
    		el1 = text_arr[i];
    		if (Array.isArray(item)) {
    			el2 = item[0];
    		} else {
    			el2 = item;
    		}
    		if (el2.indexOf('<i>') != -1) {
    			html_parser_xpath_parse(el2)
    			el2 = html_parser_xpath_text_list("//b").join(' ')
    		}
    		resultat = text_full.replace(el1, get_unescapeHTML(el2));
    	}
    	if(text_type){
    		resultat = resultat.split(/\r\n|\r|\n/g);
    	}
    	return resultat;
    }
    var resultat = fotmattedResponse(response, text_full, text_arr, text_type)
    _function_return(resultat)
 }

 function hl_google(a, b) {
 	for (var c = 0; c < b.length - 2; c += 3) {
 		var d = b.charAt(c + 2);
 		d = "a" <= d ? d.charCodeAt(0) - 87 : Number(d);
 		d = "+" == b.charAt(c + 1) ? a >>> d : a << d;
 		a = "+" == b.charAt(c) ? a + d & 4294967295 : a ^ d
 	}
 	return a
 }
    // Получение параметра tk (подписи запроса)
    var tk_google = function(a, ttk) {
    	var d = ttk.split(".");
    	var b = Number(d[0]) || 0;
    	for (var e = [], f = 0, g = 0; g < a.length; g++) {
    		var k = a.charCodeAt(g);
    		128 > k ? e[f++] = k : (2048 > k ? e[f++] = k >> 6 | 192 : (55296 == (k & 64512) && g + 1 < a.length && 56320 == (a.charCodeAt(g + 1) & 64512) ? (k = 65536 + ((k & 1023) << 10) + (a.charCodeAt(++g) & 1023),
    			e[f++] = k >> 18 | 240,
    			e[f++] = k >> 12 & 63 | 128) : e[f++] = k >> 12 | 224,
    		e[f++] = k >> 6 & 63 | 128),
    		e[f++] = k & 63 | 128)
    	}
    	a = b
    	for (f = 0; f < e.length; f++)
    		a += e[f],
    	a = hl_google(a, "+-a^+6");
    	a = hl_google(a, "+-3^+b+-f");
    	a ^= Number(d[1]) || 0;
    	0 > a && (a = (a & 2147483647) + 2147483648);
    	a %= 1E6;
    	return (a.toString() + "." + (a ^ b))
    }

    function Translator_text_spliter() {
    	var text = _function_argument("text")
    	var concat_flag = _function_argument("concat_flag")
    	var unicode_flag = _function_argument("unicode_flag")
    	var chunk_max_size = _function_argument("chunk_max_size")
    // Отрезать кусок из текста, с учетом пунктуации и старт позиции
    var cut_chunk = function(text_obj, limit, full_limit) {
        // Проверка по юникод
        if (text_obj.unicode_flag) {
        	limit -= 9;
        }
        var resultat = "",
        counter = 0;
        for (var pos = text_obj.pos_start; pos < text_obj.text.length; ++pos) {
            // Получаем символ по индексу
            var g = text_obj.text.charAt(pos);
            // Получаем код символа
            var h = g.charCodeAt(0);
            // Счетчик итераций (символов)
            counter++; // Нужен для прроверки выхода за макс лимит.
            // Проверка по юникод
            if (text_obj.unicode_flag) {
            	if (h <= 127) {
            		if (h <= 32 || forbidden_obj[h]) {
            			text_obj.pos += 3
            		} else {
            			text_obj.pos += 1
            		}
            	} else {
            		if (h <= 2047 || h >= 55296 && h <= 56319 || h >= 56320 && h <= 57343) {
            			text_obj.pos += 6
            		} else {
            			text_obj.pos += 9
            		}
            	}
            } else {
            	text_obj.pos += 1;
            }
            // Если индекс символа в предложении больше лимита (860), ставим h как флаг, в true
            h = text_obj.pos >= limit;
            // Проверяем есть ли текущий символ в списке пунктационных (точки, запятые и тд)
            if (punctuation_obj[g]) {
                text_obj.punct_start = pos; // Позиция текущего символа
                text_obj.punct_last = text_obj.pos; // Позиция след символа
                // Если вышли за лимит предложения, чекаем вышли ли за макс лимит
                if (h) {
                	h = counter > full_limit;
                }
             } else {
                // Проверка на пробельный символ
                if (" " == g) {
                    text_obj.space_start = pos; // Позиция текущего символа
                    text_obj.space_last = text_obj.pos; // Позиция след символа
                    // Если вышли за лимит предложения, чекаем вышли ли за макс лимит
                    if (h) {
                    	h = counter > full_limit;
                    }
                 }
              }
            // Проверка выхода за лимит
            // Если вышли за лимит, значит пора закругляться и где-то уже резать
            if (h) {
                // Проверяем есть ли у нас позиция пунктуац. символа
                if (text_obj.punct_start >= 0) {
                    // Режем с ласт позиции, где отрезали до этого
                    // До символа пунктуации + 1
                    resultat = text_obj.text.substring(text_obj.pos_last, text_obj.punct_start + 1);
                    // Из лимита размера текста, вычитаем то что отрезали
                    text_obj.pos -= text_obj.punct_last;
                    // Новая ласт позиция - символ после пунктуационного
                    text_obj.pos_last = text_obj.punct_start + 1;
                    // Проверяем не был ли пробел за пунктационным символом
                    if (text_obj.punct_start >= text_obj.space_start) {
                    	text_obj.space_start = -1;
                    	text_obj.space_last = 0;
                    }
                    // Если был пробел после пунктуации, записываем новую позицию у пробельного
                    else {
                    	text_obj.space_last -= text_obj.punct_last;
                    	text_obj.punct_start = -1;
                    	text_obj.punct_last = 0;
                    }
                 }
                // Проверяем есть ли у нас позиция пробельного. символа
                else if (text_obj.space_start >= 0) {
                    // Режем с ласт позиции, где отрезали до этого
                    // До пробельного символа + 1
                    resultat = text_obj.text.substring(text_obj.pos_last, text_obj.space_start + 1);
                    // Из лимита размера текста, вычитаем то что отрезали
                    text_obj.pos -= text_obj.space_last;
                    // Новая ласт позиция - символ после пробельного
                    text_obj.pos_last = text_obj.space_start + 1;
                    text_obj.space_start = -1;
                    text_obj.space_last = 0
                 }
                // Если нет пробельных или пунктуационных символов
                else {
                    // Режем с ласт позиции, где отрезали до этого
                    // До последнего найденого до лимита + 1
                    resultat = text_obj.text.substring(text_obj.pos_last, pos + 1);
                    // Зануляем счетчик лимита
                    text_obj.pos = 0;
                    // Ставим в лас позицию до отрезанного
                    text_obj.pos_last = pos + 1;
                    text_obj.punct_start = text_obj.space_start = -1;
                    text_obj.space_last = text_obj.punct_last = 0;
                 }
                // Начинаем новую итерацию цикла
                text_obj.pos_start = pos + 1;
                return resultat
             }
          }
        // Если по итогу мы не дошли до конца текста
        if (text_obj.pos_last < text_obj.text.length) {
            // Режем с ласт позиции до конца
            resultat = text_obj.text.substring(text_obj.pos_last);
            // Новая ласт позиция - фулл размер текста
            text_obj.pos_last = text_obj.text.length;
         }
         return resultat
      }
    // Массив в объект
    var arr_to_obj = function(a) {
    	for (var b = {}, c = 0; c < a.length; ++c)
    		b[a[c]] = !0;
    	return b
    }
    // Пунктационные символы
    var punctuation_obj = arr_to_obj(". , ; : \\? !".split(" "));
    // Запрещенные символы
    var forbidden_obj = arr_to_obj([34, 35, 36, 37, 38, 43, 44, 47, 58, 59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 96, 123, 124, 125, 127]);
    var create_text_obj = function(text, unicode_flag) {
    	this.text = text;
    	this.unicode_flag = !!unicode_flag;
    	this.pos_last = this.pos_start = 0;
    	this.punct_start = this.space_start = -1;
    	this.space_last = this.punct_last = this.pos = 0
    }
    // Предложение в массив
    var sentence_to_arr = function(sentence, unicode_flag, limit) {
    	var settings = {
    		limit: limit,
    		full_limit: 4294967295,
    		counter: 0
    	};
    	var resultat = [];
    	if (sentence.length < settings.limit) {
    		resultat.push(sentence);
    		return resultat;
    	}
    	if (sentence.length > settings.full_limit) {
    		fail_user("Text split error \(sentence is very big\)\!", false);
    	}
    	var text_obj = new create_text_obj(sentence, unicode_flag);
    	for (var chunk; chunk = cut_chunk(text_obj, settings.limit, settings.full_limit);) {
    		resultat.push(chunk);
    		settings.counter += chunk.length;
    		settings.full_limit -= chunk.length;
    		if (0 >= settings.full_limit) {
    			resultat.push(sentence.substring(text_obj.pos_last));
    			break;
    		}
    	}
    	return resultat
    }
    // Текст в массив
    var text_to_arr = function(text, limit, unicode_flag, concat_flag) {
    	if (typeof text == 'string') {
    		text = text.split(/\r\n|\r|\n/g);
    	}
    	if (Array.isArray(text)) {
		text = escapeHTML_arr(text);
    		var resultat = [];
    		text.forEach(function(sentence) {
                // Получаем из предложения массив
                var arr = sentence_to_arr(sentence, unicode_flag, limit);
		arr = unescapeHTML_arr(arr);
                resultat.push(arr);
             })
            // Сводим все к одномерному массиву
            if (concat_flag) {
            	return Array.prototype.concat.apply([], resultat);
            }
            return resultat;
         } else {
         	fail_user("Text split error \(unknown data type\)\!", false);
         }
      }
      var resultat = text_to_arr(text, chunk_max_size, unicode_flag, concat_flag)
      _function_return(resultat)
   }
// Подготовка тела запроса
var getQuery = function(data, query_name) {
	var resultat = [];
	data.forEach(function(item) {
		if (typeof item != 'string' || item.split(/\r\n|\r|\n/g).length > 1) {
			fail_user("Text is arr \(failed format\)\!", false);
		}
		resultat.push(query_name + '=' + encodeURIComponent(item));
	});
	return resultat.join('&')
}
    // Удаление всех пробельных символов
    var textTrim = function(data) {
    	var resultat = [];
    	data.forEach(function(item) {
    		var trimmed = item.trim();
    		if (trimmed.length) {
    			resultat.push(trimmed);
    		}
    	});
    	return resultat
    }
    var escapeHTML_arr = function(data) {
    	var resultat = [];
    	data.forEach(function(item) {
    		resultat.push(escapeHTML(item));
    	});
    	return resultat
    }
    var unescapeHTML_arr = function(data) {
    	var resultat = [];
    	data.forEach(function(item) {
    		resultat.push(get_unescapeHTML(item));
    	});
    	return resultat
    }
    // Подготовка текста
    var text_preparation = function(text, service) {
    	var services = {
    		'google': {
    			'limit': 860,
    			'query': 'q',
    			'mode': 1,
    			'ttk': '456255.3845281965'
    		},
    		'yandex': {
    			'limit': 600,
    			'query': 'text',
    			'mode': 1,
    		},
    		'baidu': {
    			'limit': 5000,
    			'query': 'q',
    			'mode': 2,
    		},
    		'bing': {
    			'limit': 1000,
    			'query': 'text',
    			'mode': 2,
    		},
    		'deepl': {
    			'limit': 5000,
    			'query': 'texts',
    			'mode': 3,
    		}
    	};
       // Тянем настройки под каждый сервис
       var limit = services[service].limit;
       var query_name = services[service].query;
       var ttk = services[service].ttk;
       var mode = services[service].mode;
        var resultat = {}; // Объект для хранения результатов
        resultat.zero = false; // Флаг проверки входных данных на пустоту
        resultat.type = true;
        if (typeof text == 'string') {
            text = text.split(/\r\n|\r|\n/g); // Конвертируем строку в массив
            resultat.type = false;            
         }
         if (Array.isArray(text)) {
            // Энкодим html символы в массиве
            var text_full = escapeHTML_arr(text);
            // Получаем чистые предложения без пробельных символов по
            text = textTrim(text_full);
            if (text.join('').length > limit) {
            	fail_user("Text arr error \(text very big\)\! "+limit+"|"+text.join('').length, false);
            } else if (!text.join('')) {
                // Текст онли пробелы и типо над выйти и не переводить
                return resultat.zero = true, resultat;
             }
             resultat.arr = text;
             resultat.full = text_full.join('\r\n');
            //ttk = "456255.3845281965"; // ft_lib
            //ttk = "464068.1397439356"; // te_lib
            resultat.tk = !!ttk ? tk_google(text.join(''), ttk) : 0;
            switch (mode) {
            	case 1: {
                    resultat.query = getQuery(text, query_name); // google, yandex
                    break;
                 }
                 case 2: {
                    resultat.query = query_name + '=' + encodeURIComponent(text.join('\r\n')); //baidu,bing,deepl
                    break;
                 }
                 case 3: {
                 	break;
                 }
                 default: {
                 	fail_user("Text error \(service not found\)\!", false);
                 }
              }
           } else {
           	fail_user("Text preparation error \(unknown data type\)\!", false);
           }
           return resultat

        }